<style>
  #phone-error {
    padding-top: 3px;
    clear: both;
  }

  .input-tip {
    font-family: open_sans;
    width: 90vw;
    font-size: 12px;
    color: #717170;
    margin: 0;
  }

  .text-input {
    padding: 8px;
    margin-top: 4px;
    background-color: white;
    background: #ffffff;
    border-radius: 8px;
    border: 1px solid #717170;
    width: 100%;
    box-sizing: border-box;
    display: block;
  }

  .checkbox-container {
    float: left;
    height: 18px;
  }

  .terms-section {
    padding-top: 30px;
    clear: both;
  }

  .terms-text {
    font-family: open_sans;
    font-size: 14px;
    line-height: 25px;
    letter-spacing: 0.4px;
    margin: -3px 0 25px 25px;
  }

  .submit-button {
    cursor: pointer;
    height: 44px;
    width: 280px;
    padding: 8px 14px;
    background: #e71316;
    border-radius: 8px;
    border-width: 0;
    color: white;
    font-family: open_sans_semi;
    font-size: 16px;
    line-height: 24px;
    text-align: center;
    text-transform: uppercase;
  }

  input[type="checkbox"] {
    display: none;
  }

  input[type="checkbox"]+label {
    background-image: url("https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/checkbox_off.png");
    background-size: cover;
    height: 18px;
    width: 18px;
    display: inline-block;
    padding: 0 0 0 0px;
  }

  input[type="checkbox"]:checked+label {
    background-image: url("https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/checkbox_on.png");
  }

  input[type="radio"] {
    display: none;
  }

  input[type="radio"]+label {
    background-image: url("https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/radio_off.png");
    background-size: cover;
    height: 22px;
    width: 22px;
    display: inline-block;
    margin-top: 10px;
    padding: 0 0 0 0px;
  }

  input[type="radio"]:checked+label {
    background-image: url("https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/radio_on.png");
  }

  .text-container {
    width: 90%;
  }

  .hidden {
    display: none !important;
  }

  .form-error {
    color: #e71316;
    font-family: open_sans;
    font-size: 12px;
    line-height: 16px;
    letter-spacing: 0.466667px;
    margin-top: 3px;
    margin-bottom: 0px;
  }

  .text-input-error {
    background: rgba(231, 19, 22, 0.2);
    border: 1px solid #E71316;
    border-radius: 8px;
  }

  #text-phonenumber {
    background-color: #F1F1F1;
    border-color: #CFCECC;
  }

  button:disabled {
    color: rgba(0, 0, 0, 0.26);
    background-color: rgba(0, 0, 0, 0.12);
  }
</style>

<form method="post" action="{{base_path}}/register">
  <input name="_csrf" type="hidden" value="{{csrf_token}}" />

  <!-- Only opt in if sms if agree to promotions? -->
  <input name="metadata[email_opt_in_flag]" type="hidden" value="true" />

  <!-- Always submitted as true if tos is true? -->
  <input name="metadata[loyalty_opt_in_flag]" type="hidden" value="true" />

  <div class="errors-container"></div>

  <div id="account-info-container" class="register-card-border">
    <h2 id="account-info-header" class="register-card-header">Account information</h2>
    <div style="display: flex; flex-direction:column; padding:24px;">
      <!-- Email -->
      <div id="email-container" class="register-card-input">
        <label for="email" class="register-field-labels">Email</label>
        <input type="email" id="email" name="email" class="text-input" autocomplete="email" value="{{{ email }}}" />
        <p class="form-error hidden" id="email-error"></p>
      </div>
      <!-- Password -->
      <div class="register-card-input">
        <label for="password" class="register-field-labels">Create Password</label>
        <p class="input-tip" id="password-requirements">
          7+ characters, at least 1 lowercase letter, 1 uppercase letter, 1 number and 1 special character
        </p>
        <input type="password" id="password" name="password" class="text-input" autocomplete="new-password" required />
        <p class="input-tip form-error hidden" id="password-error"></p>
      </div>

      <!-- Password Confirmation -->
      <div id="password-confirmation-container" class="register-card-input">
        <label for="password_confirmation" class="register-field-labels">Confirm Password</label>
        <input name="password_confirmation" id="confirm-password" required type="password" autocomplete="new-password" class="text-input" />
      </div>
      <p class="input-tip form-error hidden" id="password-confirmation-error"></p>
    </div>
  </div>

  <div id="info-section" class="register-card-border">
    <h2 class="register-card-header">Your information</h2>
    <div style="display: flex; flex-wrap: wrap; padding: 24px; justify-content: space-between;">
      <!-- First Name -->
      <div class="register-card-input">
        <label for="firstName" class="register-field-labels">First name</label>
        <input type="text" id="firstName" name="first_name" class="text-input" autocomplete="given-name" value="{{{ first_name }}}" required />
        <p class="form-error hidden" id="first-name-error"></p>
      </div>

      <!-- Last Name -->
      <div class="register-card-input">
        <label for="lastName" class="register-field-labels">Last name</label>
        <input type="text" id="lastName" name="last_name" class="text-input" autocomplete="family-name" value="{{{ last_name }}}" required />
        <p class="form-error hidden" id="last-name-error"></p>
      </div>

      <!-- Phone number -->
      <div class="register-card-input">
        <label for="phone" class="register-field-labels">Phone number</label>
        <span class="input-tip">10 digits</span>
        <input
          autocomplete="tel"
          class="text-input"
          id="phone"
          name="phoneInput"
          type="tel"
          value="{{{ phone }}}"
          pattern="\([0-9]{3}\)\s[0-9]{3}-[0-9]{4}"
          required
        />
        <p class="form-error hidden" id="phone-error"></p>
        <input type="hidden" name="phone" pattern="\+1[0-9]{10}"/>
      </div>

      <!-- Zip code -->
      <div id="zip-code-container" class="register-card-input">
        <label for="zip" class="register-field-labels">ZIP Code</label>
        <span class="input-tip">5 digits</span>
        <input type="postal" id="zip" name="metadata[zip_code]" class="text-input zip" pattern="[0-9]{5}" autocomplete="postal-code" {{{ zip }}} />
        <p class="form-error hidden" id="zip-error"></p>
      </div>
    </div>
  </div>

  <div id="birthday-promo-section" class="register-card-border">
      <h2 class="register-card-header">Save more with these benefits</h2>
      <div style="display: flex; flex-direction:column; align-items:flex-start; padding: 24px">
        <h3 class="register-card-subheader">Enjoy a free birthday treat</h3>
          <!-- Date of birth -->
          <div class="register-card-input">
            <label for="dob" class="register-field-labels">Birthday <span class="input-tip">MM-DD-YYYY (optional)</span></label>
            <input type="date" id="dob" name="birthdayInput" class="text-input dob" autocomplete="bday" value="{{{ dob }}}" max="9999-12-31"/>

            <input name="birthday[year]" type="hidden" value="" />
            <input name="birthday[month]" type="hidden" value="" />
            <input name="birthday[day]" type="hidden" value="" />
            <p class="form-error hidden" id="birthday-error">Age requirement has not been met</p>
          </div>
        <h3 class="register-card-subheader">Send me promotions</h3>
        <div class="register-promotion">
          <label class="switch">
              <input type="checkbox" name="phonePromo" id="mobile-promotion-toggle" onclick="onSmsOptInPress()" />
              <span class="slider round"></span>
          </label>
          <input type="hidden" name="metadata[sms_opt_in_flag]" />
          <span class="register-promotion-text">Texts</span>
        </div>
        <!-- Promotions Phone -->
        <div id="mobile-promotion-container" class="hidden">
          <label for="text-phonenumber" class="register-field-labels">Phone number</label>
          <input type="tel" id="text-phonenumber" name="textPhoneInput" class="text-input" autocomplete="tel" value="{{{ phone }}}" readonly />
          <input type="hidden" name="metadata[text_phonenumber]" />
        </div>
      </div>
  </div>

  <!-- Terms and Conditions -->
  <div id="tos-section" class="terms-section">
    <div class="checkbox-container">
      <input id="tos-checkbox" name="tos" value="false" type="hidden" />
      <input type="checkbox" id="tos" />
      <label for="tos" onClick="toggleTermsOptIn()"></label>
    </div>

    <div class="text-container">
      <p class="terms-text">
        I have read and accept the
        <a href="https://hutrewards.pizzahut.com/terms/?loggedin=n&variant=a&store_loyalty=unknown" target="_blank"
          class="document-link">
          Hut Rewards Terms & Conditions</a>, Pizza Hut
        <a href="https://www.pizzahut.com/assets/a/docs/terms-of-use.html" target="_blank" class="document-link">Terms
          of Use</a>,
        <a href="https://www.pizzahut.com/privacy-policy" target="_blank" class="document-link">Privacy
          Policy</a>, and
        <a href="https://www.pizzahut.com/index.php?caprivacy=#/caprivacy" target="_blank" class="document-link">
          California Notice of Financial Incentive
        </a>
      </p>
    </div>
  </div>

  <!-- Submit Button -->
  <!-- Should be disabled until tos is checked -->
  <button id="register-button" class="submit-button" disabled>Create Account</button>
</form>

<script>
  // Send event when iframe initialied
  if (window.parent) {
    window.parent.postMessage({ type: "idp-ui-initialized" }, "*");
  };

  // input fields for validation UI
  const firstNameField = document.getElementById('firstName');
  const lastNameField = document.getElementById('lastName');
  const emailField = document.getElementById('email');
  const passwordField = document.getElementById('password');
  const passwordConfirmationField = document.getElementById('confirm-password');
  const phoneNumberField = document.getElementById('phone');

  // form inputs
  const form = document.querySelector('form');
  const firstName = form.querySelector('[name="first_name"]');
  const lastName = form.querySelector('[name="last_name"]');
  const email = form.querySelector('[name="email"]');
  const password = form.querySelector('[name="password"]');
  const passwordConfirmation = form.querySelector('[name="password_confirmation"]');
  const phoneNumber = form.querySelector('[name="phoneInput"]');
  const hiddenPhoneInput = form.querySelector('[name="phone"]');
  const zip = form.querySelector('[name="metadata[zip_code]"]');
  const birthday = form.querySelector('[name="birthdayInput"]');
  const textPhone = form.querySelector('[name="textPhoneInput"]');
  const hiddenTextPhoneInput = form.querySelector('[name="metadata[text_phonenumber]"]');
  const smsOptIn = form.querySelector('[name="phonePromo"]');
  const hiddenSmsOptIn = form.querySelector('[name="metadata[sms_opt_in_flag]"]');
  const termsOptIn = form.querySelector('[name="tos"]');

  const registerButton = document.getElementById('register-button');

  // add event listeners
  firstName.addEventListener('blur', () => didUpdateFirstName(firstName.value));
  lastName.addEventListener('blur', () => didUpdateLastName(lastName.value));
  email.addEventListener('blur', () => didUpdateEmail(email.value));
  password.addEventListener('blur', () => didUpdatePassword(password.value));
  passwordConfirmation.addEventListener('blur', () => didUpdatePasswordConfirmation(passwordConfirmation.value));
  phoneNumber.addEventListener('input', (e) => handlePhoneNumberInput(e.target.value));
  phoneNumber.addEventListener('blur', () => didUpdatePhoneNumber(phoneNumber.value));
  zip.addEventListener('input', (e) => handleZipInput(e.target.value));
  zip.addEventListener('blur', () => didUpdateZip(zip.value));
  birthday.addEventListener('blur', () => didUpdateBirthday(birthday.value));
  form.addEventListener('submit', validateForm);

  function addParamsToMetadata(params) {
    const metadataInput = document.createElement('input');
    metadataInput.type = 'hidden';
    metadataInput.name = 'metadata[queryParams]';
    metadataInput.value = JSON.stringify(params);
    form.appendChild(metadataInput);
  }

  // Specific functionality for checkout account creation and to pass hutRewardsQueryParams from the promo banners
  window.addEventListener("message", function (message) {
    if(message.data && message.data.hutRewardsQueryParams) {
        addParamsToMetadata(message.data.hutRewardsQueryParams)
    }

    if (message.data && message.data.type === "submit" && message.target.origin) {
      registerButton.click();
    }
  });

  if (window.location.pathname.includes('guest_to_customer')) {
    // Remove our div border
    document.querySelector("#account-info-container").classList.remove("register-card-border");

    hideElement("#info-section");
    hideElement("#email-container");
    hideElement("#birthday-promo-section");
    hideElement("#account-info-header");
    hideElement("#register-button");
    hideElement("#tos-section");

    const passwordConfirmationContainer = document.querySelector('#password-confirmation-container');
    const zipCodeContainer = document.querySelector('#zip-code-container');
    passwordConfirmationContainer.after(zipCodeContainer);

    document.querySelector("#tos-checkbox").setAttribute('checked', true);
    document.querySelector("#tos-checkbox").setAttribute('value', true);
    registerButton.disabled = false;
  }

  // user interaction
  function onSmsOptInPress() {
    const value = document.getElementById('mobile-promotion-toggle').checked;

    switch (value) {
      case true:
        hiddenTextPhoneInput.value = hiddenPhoneInput.value;
        hiddenSmsOptIn.value = true;
        showElement('#mobile-promotion-container');
        break;
      case false:
        hiddenTextPhoneInput.value = '';
        hiddenSmsOptIn.value = false;
        hideElement('#mobile-promotion-container');
        break;
    }
  }

  function toggleTermsOptIn() {
    const newVal = termsOptIn.value === 'false' ? 'true' : 'false';
    termsOptIn.value = newVal;
    if (newVal === 'true') {
      registerButton.disabled = false;
    } else {
      registerButton.disabled = true;
    }
  }

  // validation
  function isValidName(nameValue) {
    const nameRegex = /^(?!.*[$*\\\/:<>{}();@&`|])[a-zA-Z\d]*$/;
    return nameRegex.test(nameValue);
  }

  function didUpdateFirstName(firstNameValue) {
    const firstNameError = document.getElementById('first-name-error');
    if (isValidName(firstNameValue) && firstNameValue.length <= 245) {
      firstNameField.classList.remove('text-input-error');
      firstNameError.classList.add('hidden');
      return;
    } else if (firstNameValue.length === 0) {
      firstNameError.innerText = '​Please add your first name';
    } else {
      firstNameError.innerText = 'Not a valid name';
    }
    firstNameField.classList.add('text-input-error');
    firstNameError.classList.remove('hidden');
  }

  function didUpdateLastName(lastNameValue) {
    const lastNameError = document.getElementById('last-name-error');
    if (isValidName(lastNameValue) && lastNameValue.length <= 245) {
      lastNameField.classList.remove('text-input-error');
      lastNameError.classList.add('hidden');
      return;
    } else if (lastNameValue.length === 0) {
      lastNameError.innerText = 'Please add your last name';
    } else {
      lastNameError.innerText = 'Not a valid name';
    }
    lastNameField.classList.add('text-input-error');
    lastNameError.classList.remove('hidden');
  }

  function didUpdateEmail(emailValue) {
    const emailRegex = /^[^.](?!.*\.\.)[^\s@]+[^.]@[^-.][\w.-]+[^-]\.[\w]+$/;
    const emailError = document.getElementById('email-error');
    if (emailRegex.test(emailValue) && emailValue.length <= 254) {
      emailField.classList.remove('text-input-error');
      emailError.classList.add('hidden');
      return;
    } else {
      emailError.innerText = 'Invalid email address';
    }
    emailField.classList.add('text-input-error');
    emailError.classList.remove('hidden');
  }

  function isValidPassword(passwordValue) {
    // 1+ number, 1+ lowercase, 1+ uppercase, 1+ symbol, 7+ characters - no spaces
    const passwordRegex = /^(?!.*\s)(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[*@!#$%^&+=~{}]).{7,}/;
    return passwordRegex.test(passwordValue);
  }

  function doPasswordsMatch() {
    return password.value === passwordConfirmation.value;
  }

  function didUpdatePassword(passwordValue) {
    const passwordError = document.getElementById('password-error');
    if (isValidPassword(passwordValue)) {
      passwordField.classList.remove('text-input-error');
      passwordError.classList.add('hidden');
      return;
    } else if (passwordValue.length === 0) {
      passwordError.innerText = "Please create your password";
    } else {
      passwordError.innerText = "Must contain at least 1 lowercase and 1 uppercase letter, 1 special character, and be at least 7 characters long"
    }
    passwordField.classList.add('text-input-error');
    passwordError.classList.remove('hidden');
  }

  function didUpdatePasswordConfirmation(passwordConfirmationValue) {
    const passwordConfirmationError = document.getElementById('password-confirmation-error');
    const passwordsMatch = doPasswordsMatch();
    if (passwordConfirmationValue.length === 0) {
      passwordConfirmationError.innerText = "Please confirm your password"
    } else if (doPasswordsMatch()) {
      passwordConfirmationField.classList.remove('text-input-error');
      passwordConfirmationError.classList.add('hidden');
      return;
    } else {
      passwordConfirmationError.innerText = "Passwords entries must match"
    }
    passwordConfirmationField.classList.add('text-input-error');
    passwordConfirmationError.classList.remove('hidden');
  }

  function calculateAge(birthdate) {
      const birthdateParts = birthdate.split('-');
      const birthYear = parseInt(birthdateParts[0]);
      const birthMonth = parseInt(birthdateParts[1]) - 1;
      const birthDay = parseInt(birthdateParts[2]);

      const today = new Date();
      return today.getFullYear() - birthYear - ((today.getMonth() < birthMonth || (today.getMonth() === birthMonth && today.getDate() < birthDay)) ? 1 : 0);
  }

  function didUpdateBirthday(birthdayValue) {
    const [year, month, day] = birthdayValue.split('-').map(Number);

    const yearInput = document.querySelector('[name="birthday[year]"]');
    const monthInput = document.querySelector('[name="birthday[month]"]');
    const dayInput = document.querySelector('[name="birthday[day]"]');

    // Make sure our date is actually filled out before we change the hidden fields
    if (year && month && day) {
      const age = calculateAge(`${year}-${month}-${day}`);
      if (age >= 16) {
        yearInput.value = year;
        monthInput.value = month;
        dayInput.value = day;
        hideElement('#birthday-error');
        } else {
        showElement('#birthday-error');
        }
    } else {
      // Let someone delete their birthday if they change their mind
      yearInput.value = '';
      monthInput.value = '';
      dayInput.value = '';
    }
  }

  function handlePhoneNumberInput(phoneValue) {
    // Check if we have a country code (+1) first, and remove it if so
    let phoneNoCountryCode = phoneValue;
    if (phoneValue.startsWith('+1')) {
      phoneNoCountryCode = phoneValue.slice(2, phoneValue.length);
    }
    const strippedNumber = phoneNoCountryCode.replace(/\D/g, '').slice(0, 10);
    let formattedNumber = '';
    if (strippedNumber.length >= 7) {
      formattedNumber = `(${strippedNumber.slice(0, 3)}) ${strippedNumber.slice(3, 6)}-${strippedNumber.slice(6, strippedNumber.length)}`
    } else if (strippedNumber.length >= 4) {
      formattedNumber = `(${strippedNumber.slice(0, 3)}) ${strippedNumber.slice(3, strippedNumber.length)}`
    } else if (strippedNumber.length >= 1) {
      formattedNumber = `(${strippedNumber.slice(0, strippedNumber.length)}`
    }
    phoneNumber.value = formattedNumber;
    textPhone.value = formattedNumber;
  }

  function isValidPhoneNumber(phoneValue) {
    const phoneRegex = /^[+]1[0-9]{10}$/;
    return phoneRegex.test(phoneValue);
  }

  function didUpdatePhoneNumber(phoneNumberValue) {
    const phoneError = document.getElementById('phone-error');

    // Remove styling additions, and add country code ie. +1XXXXXXXXXX
    const formattedNumber = `+1${phoneNumberValue.replace(/\D/g, '')}`;

    if (isValidPhoneNumber(formattedNumber)) {
      phoneNumberField.classList.remove('text-input-error');
      phoneError.classList.add('hidden');
      hiddenPhoneInput.value = formattedNumber;
      if (smsOptIn.checked) hiddenTextPhoneInput.value = formattedNumber;
      return;
    } else if (phoneNumberValue.length === 0) {
      phoneError.innerText = 'Please enter your phone number';
    } else {
      phoneError.innerText = 'Invalid phone number';
    }
    phoneNumberField.classList.add('text-input-error');
    phoneError.classList.remove('hidden');
  }

  function isValidZip(zipValue) {
    const zipRegex = /^[0-9]{5}$/;
    return zipRegex.test(zipValue);
  }

  function handleZipInput(zipValue) {
    const onlyDigitRegex = /[0-9]/;
    if (onlyDigitRegex.test(zipValue) && zipValue.length <= 5) {
      zip.value = zipValue;
      return;
    }
    zip.value = zipValue.slice(0, zipValue.length - 1);
  }

  function didUpdateZip(zipValue) {
    const zipError = document.getElementById('zip-error');
    if (isValidZip(zipValue)) {
      zip.classList.remove('text-input-error');
      zipError.classList.add('hidden');
      return;
    } else if (zipValue.length === 0) {
      zipError.innerText = "Please enter your ZIP code"
    } else {
      zipError.innerText = "Invalid ZIP code"
    }
    zip.classList.add('text-input-error');
    zipError.classList.remove('hidden');
  }

  function filloutHiddenPhoneFieldGuestToCustomer() {
    const nonHiddenPhoneHasValue = phoneNumberField.value !== '' && !!phoneNumberField.value;
    const hiddenPhoneHasNoValue = hiddenPhoneInput.value === '' || !hiddenPhoneInput.value;

    if(nonHiddenPhoneHasValue && hiddenPhoneHasNoValue){
        hiddenPhoneInput.value = `+1${phoneNumberField.value.replace(/\D/g, '')}`;
    }
  }

  // Validate our required fields prior to a submission
  function validateForm(event) {   
    const passwordsMatch = doPasswordsMatch();
    const isTermsAndConditionsChecked = termsOptIn.value === 'true';
    if (window.location.pathname.includes('guest_to_customer')) {
      filloutHiddenPhoneFieldGuestToCustomer();
    }
    const isPhoneValid = isValidPhoneNumber(hiddenPhoneInput.value);
    const isZipCodeValid = isValidZip(zip.value);

    if(!passwordsMatch || !isTermsAndConditionsChecked || !isPhoneValid || !isZipCodeValid){
      event.preventDefault();
    }
  }

  // helpers
  function hideElement(selector) {
    const element = document.querySelector(selector);
    element.classList.add('hidden');
  }

  function showElement(selector) {
    const element = document.querySelector(selector);
    element.classList.remove('hidden');
  }

  // Send our latest error off to the parent and let them handle it how they want
  function handleAPIErrors(errors) {
    if (errors.length) {
      const lastError = errors[errors.length - 1];
      if (window.parent) {
        window.parent.postMessage({ type: lastError }, "*");
      }
    }
  }
  handleAPIErrors(ERRORS);

  // If errors, we need to reformat our phone field
  handlePhoneNumberInput(phoneNumber.value);
</script>